Overview | Package | Class | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.vecmath
Class Matrix4f

    java.lang.Object
      javax.vecmath.Matrix4f

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable

    public class Matrix4f

extends java.lang.Object
implements java.io.Serializable, java.lang.Cloneable

A single precision floating point 4 by 4 matrix.

Author:
  Kenji hiranabe
See Also:
  Serialized Form

Field Summary
`float` | `m00` The first element of the first row.
`float` | `m01` The second element of the first row.
`float` | `m02` third element of the first row.
`float` | `m03` The fourth element of the first row.
`float` | `m10` The first element of the second row.
`float` | `m11` The second element of the second row.
`float` | `m12` The third element of the second row.
`float` | `m13` The fourth element of the second row.
`float` | `m20` The first element of the third row.
`float` | `m21` The second element of the third row.
`float` | `m22` The third element of the third row.
`float` | `m23` The fourth element of the third row.
`float` | `m30` The first element of the fourth row.
`float` | `m31` The second element of the fourth row.
`float` | `m32` The third element of the fourth row.
`float` | `m33` The fourth element of the fourth row.

Constructor Summary
`Matrix4f()` Constructs and initializes a Matrix4f to all zeros.
`Matrix4f(float[] v)` Constructs and initializes a Matrix4f from the specified 16 element array.
`Matrix4f(float m00, float m01, float m02, float m03, float m10, float m11, float m12, float m13, float m20, float m21, float m22, float m23, float m30, float m31, float m32, float m33)` Constructs and initializes a Matrix4f from the specified 16 values.
`Matrix4f(Matrix3f m1, Vector3f t1, float s)` Constructs and initializes a Matrix4f from the rotation matrix, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components.
`Matrix4f(Matrix4d m1)` Constructs a new matrix with the same values as the Matrix4d parameter.
`Matrix4f(Matrix4f m1)` Constructs a new matrix with the same values as the Matrix4f parameter.
`Matrix4f(Quat4f q1, Vector3f t1, float s)` Constructs and initializes a Matrix4f from the quaternion, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components.

Method Summary
`void` | `add(float scalar)` Adds a scalar to each component of this matrix.
`void` | `add(float scalar, Matrix4f m1)` Adds a scalar to each component of the matrix m1 and places the result into this.
`void` | `add(Matrix4f m1)` Sets the value of this matrix to sum of itself and matrix m1.
`void` | `add(Matrix4f m1, Matrix4f m2)` Sets the value of this matrix to the matrix sum of matrices m1 and m2.
`java.lang.Object` | `clone()`
`float` | `determinant()` Computes the determinant of this matrix.
`boolean` | `epsilonEquals(Matrix4f m1, float epsilon)` Returns true if the L-infinite distance between this matrix and matrix m1 is less than or equal to the epsilon parameter, otherwise returns false.
`boolean` | `equals(Matrix4f m1)` Returns true if all of the data members of Matrix4f m1 are equal to the corresponding data members in this Matrix4f.
`boolean` | `equals(java.lang.Object o1)` Returns true if the Object o1 is of type Matrix4f and all of the data members of t1 are equal to the corresponding data members in this Matrix4f.
`void` | `get(Matrix3d m1)` Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Matrix3d parameter.
`void` | `get(Matrix3f m1)` Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Matrix3f parameter.
`float` | `get(Matrix3f m1, Vector3f t1)` Performs an SVD normalization of this matrix to calculate the rotation as a 3x3 matrix, the translation, and the scale.
`void` | `get(Quat4f q1)` Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Quat4f parameter.
`void` | `get(Vector3f trans)` Retrieves the translational components of this matrix.
`void` | `getColumn(int column, float[] v)` Copies the matrix values in the specified column into the array parameter.
`void` | `getColumn(int column, Vector4f v)` Copies the matrix values in the specified column into the vector parameter.
`float` | `getElement(int row, int column)` Retrieves the value at the specified row and column of this matrix.
`java.util.List<java.lang.Float>` | `getElements()` Puts all elements of the matrix in a list of size 16.
`void` | `getRotationScale(Matrix3f m1)` Gets the upper 3x3 values of this matrix and places them into the matrix m1.
`void` | `getRow(int row, float[] v)` Copies the matrix values in the specified row into the array parameter.
`void` | `getRow(int row, Vector4f v)` Copies the matrix values in the specified row into the vector parameter.
`float` | `getScale()` Performs an SVD normalization of this matrix to calculate and return the uniform scale factor.
`int` | `hashCode()` Returns a hash number based on the data values in this object.
`void` | `invert()` Sets the value of this matrix to its inverse.
`void` | `invert(Matrix4f m1)` Sets the value of this matrix to the matrix inverse of the passed matrix m1.
`void` | `mul(float scalar)` Multiplies each element of this matrix by a scalar.
`void` | `mul(float scalar, Matrix4f m1)` Multiplies each element of matrix m1 by a scalar and places the result into this.
`void` | `mul(Matrix4f m1)` Sets the value of this matrix to the result of multiplying itself with matrix m1.
`void` | `mul(Matrix4f m1, Matrix4f m2)` Sets the value of this matrix to the result of multiplying the two argument matrices together.
`void` | `mulTransposeBoth(Matrix4f m1, Matrix4f m2)` Multiplies the transpose of matrix m1 times the transpose of matrix m2, and places the result into this.
`void` | `mulTransposeLeft(Matrix4f m1, Matrix4f m2)` Multiplies the transpose of matrix m1 times matrix m2, and places the result into this.
`void` | `mulTransposeRight(Matrix4f m1, Matrix4f m2)` Multiplies matrix m1 times the transpose of matrix m2, and places the result into this.
`void` | `negate()` Negates the value of this matrix: this = -this.
`void` | `negate(Matrix4f m1)` Sets the value of this matrix equal to the negation of of the Matrix4f parameter.
`void` | `rotX(float angle)` Sets the value of this matrix to a rotation matrix about the x axis by the passed angle.
`void` | `rotY(float angle)` Sets the value of this matrix to a rotation matrix about the y axis by the passed angle.
`void` | `rotZ(float angle)` Sets the value of this matrix to a rotation matrix about the z axis by the passed angle.
`void` | `set(AxisAngle4d a1)` Sets the value of this matrix to the matrix conversion of the single precision axis and angle argument.
`void` | `set(AxisAngle4f a1)` Sets the value of this matrix to the matrix conversion of the single precision axis and angle argument.
`void` | `set(float scale)` Sets the value of this matrix to a scale matrix with the passed scale amount.
`void` | `set(float[] m)` Sets the values in this Matrix4f equal to the row-major array parameter (ie, the first four elements of the array will be copied into the first row of this matrix, etc.).
`void` | `set(java.lang.Float[] m)`
`void` | `set(float scale, Vector3f v1)` Sets the value of this matrix to a scale and translation matrix; scale is not applied to the translation and all of the matrix values are modified.
`void` | `set(Matrix3d m1)` Sets the rotational component (upper 3x3) of this matrix to the matrix values in the double precision Matrix3d argument; the other elements of this matrix are initialized as if this were an identity matrix (ie, affine matrix with no translational component).
`void` | `set(Matrix3d m1, Vector3d t1, double scale)` Sets the value of this matrix from the rotation expressed by the rotation matrix m1, the translation t1, and the scale s.
`void` | `set(Matrix3f m1)` Sets the rotational component (upper 3x3) of this matrix to the matrix values in the single precision Matrix3f argument; the other elements of this matrix are initialized as if this were an identity matrix (ie, affine matrix with no translational component).
`void` | `set(Matrix3f m1, Vector3f t1, float scale)` Sets the value of this matrix from the rotation expressed by the rotation matrix m1, the translation t1, and the scale s.
`void` | `set(Matrix4d m1)` Sets the value of this matrix to a copy of the passed matrix m1.
`void` | `set(Matrix4f m1)` Sets the value of this matrix to a copy of the passed matrix m1.
`void` | `set(Quat4d q1)` Sets the value of this matrix to the matrix conversion of the (double precision) quaternion argument.
`void` | `set(Quat4d q1, Vector3d t1, double s)` Sets the value of this matrix from the rotation expressed by the quaternion q1, the translation t1, and the scale s.
`void` | `set(Quat4f q1)` Sets the value of this matrix to the matrix conversion of the single precision quaternion argument.
`void` | `set(Quat4f q1, Vector3f t1, float s)` Sets the value of this matrix from the rotation expressed by the quaternion q1, the translation t1, and the scale s.
`void` | `set(Vector3f v1)` Sets the value of this matrix to a translate matrix by the passed translation value.
`void` | `set(Vector3f v1, float scale)` Sets the value of this matrix to a scale and translation matrix; the translation is scaled by the scale factor and all of the matrix values are modified.
`void` | `setColumn(int column, float[] v)` Sets the specified column of this matrix4f to the four values provided.
`void` | `setColumn(int column, float x, float y, float z, float w)` Sets the specified column of this matrix4f to the four values provided.
`void` | `setColumn(int column, Vector4f v)` Sets the specified column of this matrix4f to the vector provided.
`void` | `setElement(int row, int column, float value)` Sets the specified element of this matrix4f to the value provided.
`void` | `setIdentity()` Sets this Matrix4f to identity.
`void` | `setRotation(AxisAngle4f a1)` Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the axis-angle argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the axis-angle, and then the scale is reapplied to the rotational components.
`void` | `setRotation(Matrix3d m1)` Sets the rotational component (upper 3x3) of this matrix to the matrix values in the single precision Matrix3f argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the passed rotation components, and then the scale is reapplied to the rotational components.
`void` | `setRotation(Matrix3f m1)` Sets the rotational component (upper 3x3) of this matrix to the matrix values in the single precision Matrix3f argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the passed rotation components, and then the scale is reapplied to the rotational components.
`void` | `setRotation(Quat4d q1)` Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the quaternion argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the quaternion, and then the scale is reapplied to the rotational components.
`void` | `setRotation(Quat4f q1)` Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the quaternion argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the quaternion, and then the scale is reapplied to the rotational components.
`void` | `setRotationScale(Matrix3f m1)` Replaces the upper 3x3 matrix values of this matrix with the values in the matrix m1.
`void` | `setRow(int row, float[] v)` Sets the specified row of this matrix4f to the four values provided.
`void` | `setRow(int row, float x, float y, float z, float w)` Sets the specified row of this matrix4f to the four values provided.
`void` | `setRow(int row, Vector4f v)` Sets the specified row of this matrix4f to the Vector provided.
`void` | `setScale(float scale)` Sets the scale component of the current matrix by factoring out the current scale (by doing an SVD) from the rotational component and multiplying by the new scale.
`void` | `setTranslation(Vector3f trans)` Modifies the translational components of this matrix to the values of the Vector3f argument; the other values of this matrix are not modified.
`void` | `setZero()` Sets this matrix to all zeros.
`void` | `sub(Matrix4f m1)` Sets the value of this matrix to the matrix difference of itself and matrix m1 (this = this - m1).
`void` | `sub(Matrix4f m1, Matrix4f m2)` Sets the value of this matrix to the matrix difference of matrices m1 and m2.
`java.lang.String` | `toString()` Returns a string that contains the values of this Matrix4f.
`void` | `transform(Point3f point)` Transforms the point parameter with this Matrix4f and places the result back into point.
`void` | `transform(Point3f point, Point3f pointOut)` Transforms the point parameter with this Matrix4f and places the result into pointOut.
`void` | `transform(Tuple4f vec)` Transform the vector vec using this Matrix4f and place the result back into vec.
`void` | `transform(Tuple4f vec, Tuple4f vecOut)` Transform the vector vec using this Matrix4f and place the result into vecOut.
`void` | `transform(Vector3f normal)` Transforms the normal parameter by this transform and places the value back into normal.
`void` | `transform(Vector3f normal, Vector3f normalOut)` Transforms the normal parameter by this Matrix4f and places the value into normalOut.
`void` | `transpose()` Sets the value of this matrix to its transpose.
`void` | `transpose(Matrix4f m1)` Sets the value of this matrix to the transpose of the argument matrix

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### m00

    public float m00

  The first element of the first row.

### m01

    public float m01

  The second element of the first row.

### m02

    public float m02

  third element of the first row.

### m03

    public float m03

  The fourth element of the first row.

### m10

    public float m10

  The first element of the second row.

### m11

    public float m11

  The second element of the second row.

### m12

    public float m12

  The third element of the second row.

### m13

    public float m13

  The fourth element of the second row.

### m20

    public float m20

  The first element of the third row.

### m21

    public float m21

  The second element of the third row.

### m22

    public float m22

  The third element of the third row.

### m23

    public float m23

  The fourth element of the third row.

### m30

    public float m30

  The first element of the fourth row.

### m31

    public float m31

  The second element of the fourth row.

### m32

    public float m32

  The third element of the fourth row.

### m33

    public float m33

  The fourth element of the fourth row.

Constructor Detail

### Matrix4f

    public Matrix4f()

  Constructs and initializes a Matrix4f to all zeros.

### Matrix4f

    public Matrix4f(float[] v)

  Constructs and initializes a Matrix4f from the specified 16 element array. this.m00 =v[0], this.m01=v[1], etc.

  Parameters:
    `v` - the array of length 16 containing in order

### Matrix4f

    public Matrix4f(float m00,
                    float m01,
                    float m02,
                    float m03,
                    float m10,
                    float m11,
                    float m12,
                    float m13,
                    float m20,
                    float m21,
                    float m22,
                    float m23,
                    float m30,
                    float m31,
                    float m32,
                    float m33)

  Constructs and initializes a Matrix4f from the specified 16 values.

  Parameters:
    `m00` - the [0][0] element
    `m01` - the [0][1] element
    `m02` - the [0][2] element
    `m03` - the [0][3] element
    `m10` - the [1][0] element
    `m11` - the [1][1] element
    `m12` - the [1][2] element
    `m13` - the [1][3] element
    `m20` - the [2][0] element
    `m21` - the [2][1] element
    `m22` - the [2][2] element
    `m23` - the [2][3] element
    `m30` - the [3][0] element
    `m31` - the [3][1] element
    `m32` - the [3][2] element
    `m33` - the [3][3] element

### Matrix4f

    public Matrix4f(Matrix3f m1,
                    Vector3f t1,
                    float s)

  Constructs and initializes a Matrix4f from the rotation matrix, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components.

  Parameters:
    `m1` - The rotation matrix representing the rotational components
    `t1` - The translational components of the matrix
    `s` - The scale value applied to the rotational components

### Matrix4f

    public Matrix4f(Matrix4d m1)

  Constructs a new matrix with the same values as the Matrix4d parameter.

  Parameters:
    `m1` - The source matrix.

### Matrix4f

    public Matrix4f(Matrix4f m1)

  Constructs a new matrix with the same values as the Matrix4f parameter.

  Parameters:
    `m1` - The source matrix.

### Matrix4f

    public Matrix4f(Quat4f q1,
                    Vector3f t1,
                    float s)

  Constructs and initializes a Matrix4f from the quaternion, translation, and scale values; the scale is applied only to the rotational components of the matrix (upper 3x3) and not to the translational components.

  Parameters:
    `q1` - The quaternion value representing the rotational component
    `t1` - The translational component of the matrix
    `s` - The scale value applied to the rotational components

Method Detail

### add

    public final void add(float scalar)

  Adds a scalar to each component of this matrix.

  Parameters:
    `scalar` - The scalar adder.

### add

    public final void add(float scalar,
                          Matrix4f m1)

  Adds a scalar to each component of the matrix m1 and places the result into this. Matrix m1 is not modified.

  Parameters:
    `scalar` - The scalar adder.

### add

    public final void add(Matrix4f m1)

  Sets the value of this matrix to sum of itself and matrix m1.

  Parameters:
    `m1` - the other matrix

### add

    public final void add(Matrix4f m1,
                          Matrix4f m2)

  Sets the value of this matrix to the matrix sum of matrices m1 and m2.

  Parameters:
    `m1` - the first matrix
    `m2` - the second matrix

### clone

    public java.lang.Object clone()

  Overrides:
    `clone` in class `java.lang.Object`

### determinant

    public final float determinant()

  Computes the determinant of this matrix.

  Returns:
    the determinant of the matrix

### epsilonEquals

    public boolean epsilonEquals(Matrix4f m1,
                                 float epsilon)

  Returns true if the L-infinite distance between this matrix and matrix m1 is less than or equal to the epsilon parameter, otherwise returns false. The L-infinite distance is equal to MAX[i=0,1,2,3 ; j=0,1,2,3 ; abs(this.m(i,j) - m1.m(i,j)]

  Parameters:
    `m1` - The matrix to be compared to this matrix
    `epsilon` - the threshold value

### equals

    public boolean equals(Matrix4f m1)

  Returns true if all of the data members of Matrix4f m1 are equal to the corresponding data members in this Matrix4f.

  Parameters:
    `m1` - The matrix with which the comparison is made.
  Returns:
    true or false

### equals

    public boolean equals(java.lang.Object o1)

  Returns true if the Object o1 is of type Matrix4f and all of the data members of t1 are equal to the corresponding data members in this Matrix4f.

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `o1` - the object with which the comparison is made.

### get

    public final void get(Matrix3d m1)

  Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Matrix3d parameter.

  Parameters:
    `m1` - matrix into which the rotational component is placed

### get

    public final void get(Matrix3f m1)

  Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Matrix3f parameter.

  Parameters:
    `m1` - matrix into which the rotational component is placed

### get

    public final float get(Matrix3f m1,
                           Vector3f t1)

  Performs an SVD normalization of this matrix to calculate the rotation as a 3x3 matrix, the translation, and the scale. None of the matrix values are modified.

  Parameters:
    `m1` - The normalized matrix representing the rotation
    `t1` - The translation component
  Returns:
    The scale component of this transform

### get

    public final void get(Quat4f q1)

  Performs an SVD normalization of this matrix in order to acquire the normalized rotational component; the values are placed into the Quat4f parameter.

  Parameters:
    `q1` - quaternion into which the rotation component is placed

### get

    public final void get(Vector3f trans)

  Retrieves the translational components of this matrix.

  Parameters:
    `trans` - the vector that will receive the translational component

### getColumn

    public final void getColumn(int column,
                                float[] v)

  Copies the matrix values in the specified column into the array parameter.

  Parameters:
    `column` - the matrix column
    `v` - The array into which the matrix column values will be copied

### getColumn

    public final void getColumn(int column,
                                Vector4f v)

  Copies the matrix values in the specified column into the vector parameter.

  Parameters:
    `column` - the matrix column
    `v` - The vector into which the matrix column values will be copied

### getElement

    public final float getElement(int row,
                                  int column)

  Retrieves the value at the specified row and column of this matrix.

  Parameters:
    `row` - the row number to be retrieved (zero indexed)
    `column` - the column number to be retrieved (zero indexed)
  Returns:
    the value at the indexed element

### getElements

    public final java.util.List<java.lang.Float> getElements()

  Puts all elements of the matrix in a list of size 16. The elements are listet in a row.

  Returns:
    list of elements

### getRotationScale

    public final void getRotationScale(Matrix3f m1)

  Gets the upper 3x3 values of this matrix and places them into the matrix m1.

  Parameters:
    `m1` - The matrix that will hold the values

### getRow

    public final void getRow(int row,
                             float[] v)

  Copies the matrix values in the specified row into the array parameter.

  Parameters:
    `row` - the matrix row
    `v` - The array into which the matrix row values will be copied

### getRow

    public final void getRow(int row,
                             Vector4f v)

  Copies the matrix values in the specified row into the vector parameter.

  Parameters:
    `row` - the matrix row
    `v` - The vector into which the matrix row values will be copied

### getScale

    public final float getScale()

  Performs an SVD normalization of this matrix to calculate and return the uniform scale factor. This matrix is not modified.

  Returns:
    the scale factor of this matrix

### hashCode

    public int hashCode()

  Returns a hash number based on the data values in this object. Two different Matrix4f objects with identical data values (ie, returns true for equals(Matrix4f) ) will return the same hash number. Two objects with different data members may return the same hash value, although this is not likely.

  Overrides:
    `hashCode` in class `java.lang.Object`
  Returns:
    the integer hash value

### invert

    public final void invert()

  Sets the value of this matrix to its inverse.

### invert

    public final void invert(Matrix4f m1)

  Sets the value of this matrix to the matrix inverse of the passed matrix m1.

  Parameters:
    `m1` - the matrix to be inverted

### mul

    public final void mul(float scalar)

  Multiplies each element of this matrix by a scalar.

  Parameters:
    `scalar` - The scalar multiplier.

### mul

    public final void mul(float scalar,
                          Matrix4f m1)

  Multiplies each element of matrix m1 by a scalar and places the result into this. Matrix m1 is not modified.

  Parameters:
    `scalar` - The scalar multiplier.
    `m1` - The original matrix.

### mul

    public final void mul(Matrix4f m1)

  Sets the value of this matrix to the result of multiplying itself with matrix m1.

  Parameters:
    `m1` - the other matrix

### mul

    public final void mul(Matrix4f m1,
                          Matrix4f m2)

  Sets the value of this matrix to the result of multiplying the two argument matrices together.

  Parameters:
    `m1` - the first matrix
    `m2` - the second matrix

### mulTransposeBoth

    public final void mulTransposeBoth(Matrix4f m1,
                                       Matrix4f m2)

  Multiplies the transpose of matrix m1 times the transpose of matrix m2, and places the result into this.

  Parameters:
    `m1` - The matrix on the left hand side of the multiplication
    `m2` - The matrix on the right hand side of the multiplication

### mulTransposeLeft

    public final void mulTransposeLeft(Matrix4f m1,
                                       Matrix4f m2)

  Multiplies the transpose of matrix m1 times matrix m2, and places the result into this.

  Parameters:
    `m1` - The matrix on the left hand side of the multiplication
    `m2` - The matrix on the right hand side of the multiplication

### mulTransposeRight

    public final void mulTransposeRight(Matrix4f m1,
                                        Matrix4f m2)

  Multiplies matrix m1 times the transpose of matrix m2, and places the result into this.

  Parameters:
    `m1` - The matrix on the left hand side of the multiplication
    `m2` - The matrix on the right hand side of the multiplication

### negate

    public final void negate()

  Negates the value of this matrix: this = -this.

### negate

    public final void negate(Matrix4f m1)

  Sets the value of this matrix equal to the negation of of the Matrix4f parameter.

  Parameters:
    `m1` - The source matrix

### rotX

    public final void rotX(float angle)

  Sets the value of this matrix to a rotation matrix about the x axis by the passed angle.

  Parameters:
    `angle` - the angle to rotate about the X axis in radians

### rotY

    public final void rotY(float angle)

  Sets the value of this matrix to a rotation matrix about the y axis by the passed angle.

  Parameters:
    `angle` - the angle to rotate about the Y axis in radians

### rotZ

    public final void rotZ(float angle)

  Sets the value of this matrix to a rotation matrix about the z axis by the passed angle.

  Parameters:
    `angle` - the angle to rotate about the Z axis in radians

### set

    public final void set(AxisAngle4d a1)

  Sets the value of this matrix to the matrix conversion of the single precision axis and angle argument.

  Parameters:
    `a1` - the axis and angle to be converted

### set

    public final void set(AxisAngle4f a1)

  Sets the value of this matrix to the matrix conversion of the single precision axis and angle argument.

  Parameters:
    `a1` - the axis and angle to be converted

### set

    public final void set(float scale)

  Sets the value of this matrix to a scale matrix with the passed scale amount.

  Parameters:
    `scale` - the scale factor for the matrix

### set

    public final void set(float[] m)

  Sets the values in this Matrix4f equal to the row-major array parameter (ie, the first four elements of the array will be copied into the first row of this matrix, etc.).

### set

    public final void set(java.lang.Float[] m)

### set

    public final void set(float scale,
                          Vector3f v1)

  Sets the value of this matrix to a scale and translation matrix; scale is not applied to the translation and all of the matrix values are modified.

  Parameters:
    `scale` - the scale factor for the matrix
    `v1` - the translation amount

### set

    public final void set(Matrix3d m1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix values in the double precision Matrix3d argument; the other elements of this matrix are initialized as if this were an identity matrix (ie, affine matrix with no translational component).

  Parameters:
    `m1` - the 3x3 matrix

### set

    public final void set(Matrix3d m1,
                          Vector3d t1,
                          double scale)

  Sets the value of this matrix from the rotation expressed by the rotation matrix m1, the translation t1, and the scale s. The translation is not modified by the scale.

  Parameters:
    `m1` - The rotation component
    `t1` - The translation component
    `scale` - The scale component

### set

    public final void set(Matrix3f m1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix values in the single precision Matrix3f argument; the other elements of this matrix are initialized as if this were an identity matrix (ie, affine matrix with no translational component).

  Parameters:
    `m1` - the 3x3 matrix

### set

    public final void set(Matrix3f m1,
                          Vector3f t1,
                          float scale)

  Sets the value of this matrix from the rotation expressed by the rotation matrix m1, the translation t1, and the scale s. The translation is not modified by the scale.

  Parameters:
    `m1` - The rotation component
    `t1` - The translation component
    `scale` - The scale component

### set

    public final void set(Matrix4d m1)

  Sets the value of this matrix to a copy of the passed matrix m1.

  Parameters:
    `m1` - the matrix to be copied

### set

    public final void set(Matrix4f m1)

  Sets the value of this matrix to a copy of the passed matrix m1.

  Parameters:
    `m1` - the matrix to be copied

### set

    public final void set(Quat4d q1)

  Sets the value of this matrix to the matrix conversion of the (double precision) quaternion argument.

  Parameters:
    `q1` - the quaternion to be converted

### set

    public final void set(Quat4d q1,
                          Vector3d t1,
                          double s)

  Sets the value of this matrix from the rotation expressed by the quaternion q1, the translation t1, and the scale s.

  Parameters:
    `q1` - the rotation expressed as a quaternion
    `t1` - the translation
    `s` - the scale value

### set

    public final void set(Quat4f q1)

  Sets the value of this matrix to the matrix conversion of the single precision quaternion argument.

  Parameters:
    `q1` - the quaternion to be converted

### set

    public final void set(Quat4f q1,
                          Vector3f t1,
                          float s)

  Sets the value of this matrix from the rotation expressed by the quaternion q1, the translation t1, and the scale s.

  Parameters:
    `q1` - the rotation expressed as a quaternion
    `t1` - the translation
    `s` - the scale value

### set

    public final void set(Vector3f v1)

  Sets the value of this matrix to a translate matrix by the passed translation value.

  Parameters:
    `v1` - the translation amount

### set

    public final void set(Vector3f v1,
                          float scale)

  Sets the value of this matrix to a scale and translation matrix; the translation is scaled by the scale factor and all of the matrix values are modified.

  Parameters:
    `v1` - the translation amount
    `scale` - the scale factor for the matrix

### setColumn

    public final void setColumn(int column,
                                float[] v)

  Sets the specified column of this matrix4f to the four values provided.

  Parameters:
    `column` - the column number to be modified (zero indexed)
    `v` - the replacement column

### setColumn

    public final void setColumn(int column,
                                float x,
                                float y,
                                float z,
                                float w)

  Sets the specified column of this matrix4f to the four values provided.

  Parameters:
    `column` - the column number to be modified (zero indexed)
    `x` - the first row element
    `y` - the second row element
    `z` - the third row element
    `w` - the fourth row element

### setColumn

    public final void setColumn(int column,
                                Vector4f v)

  Sets the specified column of this matrix4f to the vector provided.

  Parameters:
    `column` - the column number to be modified (zero indexed)
    `v` - the replacement column

### setElement

    public final void setElement(int row,
                                 int column,
                                 float value)

  Sets the specified element of this matrix4f to the value provided.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `column` - the column number to be modified (zero indexed)
    `value` - the new value

### setIdentity

    public final void setIdentity()

  Sets this Matrix4f to identity.

### setRotation

    public final void setRotation(AxisAngle4f a1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the axis-angle argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the axis-angle, and then the scale is reapplied to the rotational components.

  Parameters:
    `a1` - the axis-angle to be converted (x, y, z, angle)

### setRotation

    public final void setRotation(Matrix3d m1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix values in the single precision Matrix3f argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the passed rotation components, and then the scale is reapplied to the rotational components.

  Parameters:
    `m1` - single precision 3x3 matrix

### setRotation

    public final void setRotation(Matrix3f m1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix values in the single precision Matrix3f argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the passed rotation components, and then the scale is reapplied to the rotational components.

  Parameters:
    `m1` - single precision 3x3 matrix

### setRotation

    public final void setRotation(Quat4d q1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the quaternion argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the quaternion, and then the scale is reapplied to the rotational components.

  Parameters:
    `q1` - the quaternion that specifies the rotation

### setRotation

    public final void setRotation(Quat4f q1)

  Sets the rotational component (upper 3x3) of this matrix to the matrix equivalent values of the quaternion argument; the other elements of this matrix are unchanged; a singular value decomposition is performed on this object's upper 3x3 matrix to factor out the scale, then this object's upper 3x3 matrix components are replaced by the matrix equivalent of the quaternion, and then the scale is reapplied to the rotational components.

  Parameters:
    `q1` - the quaternion that specifies the rotation

### setRotationScale

    public final void setRotationScale(Matrix3f m1)

  Replaces the upper 3x3 matrix values of this matrix with the values in the matrix m1.

  Parameters:
    `m1` - The matrix that will be the new upper 3x3

### setRow

    public final void setRow(int row,
                             float[] v)

  Sets the specified row of this matrix4f to the four values provided.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `v` - the replacement row

### setRow

    public final void setRow(int row,
                             float x,
                             float y,
                             float z,
                             float w)

  Sets the specified row of this matrix4f to the four values provided.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `x` - the first column element
    `y` - the second column element
    `z` - the third column element
    `w` - the fourth column element

### setRow

    public final void setRow(int row,
                             Vector4f v)

  Sets the specified row of this matrix4f to the Vector provided.

  Parameters:
    `row` - the row number to be modified (zero indexed)
    `v` - the replacement row

### setScale

    public final void setScale(float scale)

  Sets the scale component of the current matrix by factoring out the current scale (by doing an SVD) from the rotational component and multiplying by the new scale.

  Parameters:
    `scale` - the new scale amount

### setTranslation

    public void setTranslation(Vector3f trans)

  Modifies the translational components of this matrix to the values of the Vector3f argument; the other values of this matrix are not modified.

  Parameters:
    `trans` - the translational component

### setZero

    public final void setZero()

  Sets this matrix to all zeros.

### sub

    public final void sub(Matrix4f m1)

  Sets the value of this matrix to the matrix difference of itself and matrix m1 (this = this - m1).

  Parameters:
    `m1` - the other matrix

### sub

    public final void sub(Matrix4f m1,
                          Matrix4f m2)

  Sets the value of this matrix to the matrix difference of matrices m1 and m2.

  Parameters:
    `m1` - the first matrix
    `m2` - the second matrix

### toString

    public java.lang.String toString()

  Returns a string that contains the values of this Matrix4f.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    the String representation

### transform

    public final void transform(Point3f point)

  Transforms the point parameter with this Matrix4f and places the result back into point. The fourth element of the point input paramter is assumed to be one.

  Parameters:
    `point` - the input point to be transformed.

### transform

    public final void transform(Point3f point,
                                Point3f pointOut)

  Transforms the point parameter with this Matrix4f and places the result into pointOut. The fourth element of the point input paramter is assumed to be one.

  Parameters:
    `point` - the input point to be transformed.
    `pointOut` - the transformed point

### transform

    public final void transform(Tuple4f vec)

  Transform the vector vec using this Matrix4f and place the result back into vec.

  Parameters:
    `vec` - the single precision vector to be transformed

### transform

    public final void transform(Tuple4f vec,
                                Tuple4f vecOut)

  Transform the vector vec using this Matrix4f and place the result into vecOut.

  Parameters:
    `vec` - the single precision vector to be transformed
    `vecOut` - the vector into which the transformed values are placed

### transform

    public final void transform(Vector3f normal)

  Transforms the normal parameter by this transform and places the value back into normal. The fourth element of the normal is assumed to be zero.

  Parameters:
    `normal` - the input normal to be transformed.

### transform

    public final void transform(Vector3f normal,
                                Vector3f normalOut)

  Transforms the normal parameter by this Matrix4f and places the value into normalOut. The fourth element of the normal is assumed to be zero.

  Parameters:
    `normal` - the input normal to be transformed.
    `normalOut` - the transformed normal

### transpose

    public final void transpose()

  Sets the value of this matrix to its transpose.

### transpose

    public final void transpose(Matrix4f m1)

  Sets the value of this matrix to the transpose of the argument matrix

  Parameters:
    `m1` - the matrix to be transposed

Overview | Package | Class | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD